Subject: bug#78187: tsx-ts-mode: wrong indentation of object parameters

From: Konstantin Kharlamov <[email-masked]>
Date: Thu, 01 May 2025 19:56:12 +0700

Given this snippet indented as expected:

    interface iface { f1: string,
                      f2: string
    }

indenting `f2` gives:

    interface iface { f1: string,
      f2: string
    }

May not be the best example, but JavaScript/TypeScript are heavy users of curly braces, and sometimes I do want to write the first field on the line with opening curly brace, which usually implies aligning other fields to it.

---------

I spent quite some time trying to write a patch for this, but I am at loss. The closest I come to a solution is a rule:

    ((node-is "property_signature") prev-sibling 0)

it works correctly for every param starting with 2nd, but it misindents the 1st parameter. Probably some condition required like "for the 1st parameter do the offset, for consequent ones follow previous siblings indentation". But I have no idea how to do that.

I looked at `c++-ts-mode` (which does it right) for inspiration, but couldn't figure out what it does in the same situation.